﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AirFighter.Entities;

namespace AirFighter.DrawningObjects
{
    public static class ExtentionDrawningAirFighter
    {
        public static DrawningAirFighter? CreateDrawningAirFighter(this string info, char separatorForObject, int width, int height)
        {
            string[] strs = info.Split(separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawningAirFighter(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]), width, height);
            }
            else if (strs.Length == 6)
            {
                return new DrawningAirFighterMilitary(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]),
                Color.FromName(strs[2]),
                Color.FromName(strs[3]),
                Convert.ToBoolean(strs[4]),
                Convert.ToBoolean(strs[5]), width, height);
            }
            return null;
        }
        public static string GetDataForSave(this DrawningAirFighter drawningAirFighter,
        char separatorForObject)
        {
            var fighter = drawningAirFighter.EntityAirFighter;
            if (fighter == null)
            {
                return string.Empty;
            }
            var str =
            $"{fighter.Speed}{separatorForObject}{fighter.Weight}{separatorForObject}{fighter.BodyColor.Name}";
            if (fighter is not EntityAirFighterMilitary fighterMilitary)
            {
                return str;
            }
            return
            $"{str}{separatorForObject}{fighterMilitary.AdditionalColor.Name}{separatorForObject}{fighterMilitary.Wing}{separatorForObject}{fighterMilitary.Rocket}";
        }
    }
}