﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using AirFighter.DrawningObjects;
using AirFighter.Drawnings;

namespace AirFighter.MovementStrategy
{
    public class DrawningObjectAirFighter : IMoveableObject
    {
        private readonly DrawningAirFighter? _drawningAirFighter = null;
        public DrawningObjectAirFighter(DrawningAirFighter drawningAirFighter)
        {
            _drawningAirFighter = drawningAirFighter;
        }
        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (_drawningAirFighter == null || _drawningAirFighter.EntityAirFighter ==
                null)
                {
                    return null;
                }
                return new ObjectParameters(_drawningAirFighter.GetPosX, _drawningAirFighter.GetPosY, _drawningAirFighter.GetWidth, _drawningAirFighter.GetHeight);
            }
        }
        public int GetStep => (int)(_drawningAirFighter?.EntityAirFighter?.Step ?? 0);
        public bool CheckCanMove(DirectionAirFighter direction) =>
        _drawningAirFighter?.CanMove(direction) ?? false;
        public void MoveObject(DirectionAirFighter direction) =>
        _drawningAirFighter?.MoveTransport(direction);
        public void SetPosition(int x, int y)
        {
            if (_drawningAirFighter != null)
            {
                _drawningAirFighter.SetPosition(x, y);
            }
        }
        public void Draw(Graphics g)
        {
            if (_drawningAirFighter != null)
            {
                _drawningAirFighter.DrawTransport(g);
            }
        }
    }
}
